/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModelProperty;

import java.io.IOException;
import java.util.Objects;

/**
 * ForgotPasswordRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class ForgotPasswordRequest {
  @SerializedName("username")
  private String username = null;

  @SerializedName("confirmation_language")
  private String confirmationLanguage = null;

  @SerializedName("confirmation_template")
  private String confirmationTemplate = null;

  /**
   * Type of channel. It can either be email or sms.
   */
  @JsonAdapter(ChannelTypeEnum.Adapter.class)
  public enum ChannelTypeEnum {
    EMAIL("email"),
    
    SMS("sms");

    private String value;

    ChannelTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ChannelTypeEnum fromValue(String text) {
      for (ChannelTypeEnum b : ChannelTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ChannelTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ChannelTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ChannelTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ChannelTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("channel_type")
  private ChannelTypeEnum channelType = null;

  public ForgotPasswordRequest username(String username) {
    this.username = username;
    return this;
  }

   /**
   * UserName whos password is to be changed
   * @return username
  **/
  @ApiModelProperty(example = "johndoe", required = true, value = "UserName whos password is to be changed")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public ForgotPasswordRequest confirmationLanguage(String confirmationLanguage) {
    this.confirmationLanguage = confirmationLanguage;
    return this;
  }

   /**
   * Language in which the confirmation email will be sent. (ISO 639-1 two letters code)
   * @return confirmationLanguage
  **/
  @ApiModelProperty(example = "en", value = "Language in which the confirmation email will be sent. (ISO 639-1 two letters code)")
  public String getConfirmationLanguage() {
    return confirmationLanguage;
  }

  public void setConfirmationLanguage(String confirmationLanguage) {
    this.confirmationLanguage = confirmationLanguage;
  }

  public ForgotPasswordRequest confirmationTemplate(String confirmationTemplate) {
    this.confirmationTemplate = confirmationTemplate;
    return this;
  }

   /**
   * Preconfigured email template
   * @return confirmationTemplate
  **/
  @ApiModelProperty(example = "greatPartner_forgotPasswordTemplate", value = "Preconfigured email template")
  public String getConfirmationTemplate() {
    return confirmationTemplate;
  }

  public void setConfirmationTemplate(String confirmationTemplate) {
    this.confirmationTemplate = confirmationTemplate;
  }

  public ForgotPasswordRequest channelType(ChannelTypeEnum channelType) {
    this.channelType = channelType;
    return this;
  }

   /**
   * Type of channel. It can either be email or sms.
   * @return channelType
  **/
  @ApiModelProperty(example = "email", value = "Type of channel. It can either be email or sms.")
  public ChannelTypeEnum getChannelType() {
    return channelType;
  }

  public void setChannelType(ChannelTypeEnum channelType) {
    this.channelType = channelType;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ForgotPasswordRequest forgotPasswordRequest = (ForgotPasswordRequest) o;
    return Objects.equals(this.username, forgotPasswordRequest.username) &&
        Objects.equals(this.confirmationLanguage, forgotPasswordRequest.confirmationLanguage) &&
        Objects.equals(this.confirmationTemplate, forgotPasswordRequest.confirmationTemplate) &&
        Objects.equals(this.channelType, forgotPasswordRequest.channelType);
  }

  @Override
  public int hashCode() {
    return Objects.hash(username, confirmationLanguage, confirmationTemplate, channelType);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ForgotPasswordRequest {\n");
    
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    confirmationLanguage: ").append(toIndentedString(confirmationLanguage)).append("\n");
    sb.append("    confirmationTemplate: ").append(toIndentedString(confirmationTemplate)).append("\n");
    sb.append("    channelType: ").append(toIndentedString(channelType)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

